/* GScript
 * gscriptx.h:
 *
 * Copyright (C) 1999 Red Hat Software
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GSCRIPTX_H__
#define __GSCRIPTX_H__

#include <glib.h>
#include <gscript.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <X11/Xlib.h>

#define G_SCRIPT_RENDER_TYPE_X "GScriptRenderX"

typedef struct _GScriptXCFont GScriptXCFont;

struct _GScriptXCFont {
  /*< private >*/
  GScriptCFont font;

  /*< public >*/
  Display *display;
  XFontStruct *font_struct;
};

/* Calls for applications
 */
GScriptFont *g_script_x_load_font (Display *display,
				   gchar   *spec);
 
void g_script_x_render  (Display       *display, 
			 Drawable       d,
		 	 GC             gc,
			 GGlyphString *glyphs,
			 gint           x, 
			 gint           y);
void g_script_x_extents (GGlyphString *glyphs,
			 gint          *lbearing, 
			 gint          *rbearing,
			 gint          *width, 
			 gint          *ascent, 
			 gint          *descent,
			 gint          *logical_ascent,
			 gint          *logical_descent);
void g_script_x_glyph_extents (GGlyph        *glyph,
			       gint          *lbearing, 
			       gint          *rbearing,
			       gint          *width, 
			       gint          *ascent, 
			       gint          *descent,
			       gint          *logical_ascent,
			       gint          *logical_descent);

/* Calls for rendering modules
 */
GScriptCFont *g_script_x_find_cfont (GScriptFont *font,
				     gchar       *charset);
void g_script_x_list_cfonts (GScriptFont *font,
			     gchar  **charsets,
			     gint     n_charsets,
			     gchar ***xlfds,
			     gint    *n_xlfds);

gboolean g_script_x_xlfd_get_ranges (GScriptFont *font,
				     gchar       *xlfd,
				     gint       **ranges,
				     gint        *n_ranges);

GScriptCFont *g_script_x_load_xlfd (GScriptFont *font,
				    gchar       *xlfd);

			   
#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GSCRIPTX_H__ */




